'''
Created on Nov 14, 2019

@author: deeejas
'''
import fitz
import re

class itemList(object):
    def __init__(self, item_list):
        self.item_list = item_list

        self.codes = []
        for c in self.item_list:
            c = c.split(1*' '+'\n')[1]
            if c != '':
                i = re.search('(?<=ROSP-)[0-9]+', c)
                if i:
                    c = c.replace('ROSP-', '')
                self.codes.append(c)

        self.qnt = []
        for c in self.item_list:
            try:
                if not isinstance(int(c.split(1*' '+'\n')[3]), int):
                    c = c.split(1*' '+'\n')[4]
                else:
                    c = c.split(1*' '+'\n')[3]
                if c != '':
                    self.qnt.append(c)
            except ValueError:
                c = c.split(1*' '+'\n')[4]
                if c != '':
                    self.qnt.append(c)

        self.net_val = []
        for c in self.item_list:
            try:
                if not isinstance(int(c.split(1*' '+'\n')[3]), int):
                    try:
                        c = c.split(1*' '+'\n')[5]
                    except IndexError:
                        c = c.split(1*' '+'\n')[4]
                else:
                    c = c.split(1*' '+'\n')[4]
                if c != '':
                    self.net_val.append(c)
            except ValueError:
                try:
                    c = c.split(1*' '+'\n')[5]
                except IndexError:
                    c = c.split(1*' '+'\n')[4]
                if c != '':
                    self.net_val.append(c)
        
        self.disc = ['0' for i in range(len(self.item_list)-1)]
        

    def __getitem__(self, k):
        return self.__dict__[k]


class atlasInvoice(object):
    '''
    classdocs
    '''
    def __init__(self, invoice):
        '''
        Constructor
        '''
        self.doc = fitz.open(invoice)
        self.fpage = self.doc.loadPage(0)
        self.cnt = self.fpage.getText('text')
        self.items_start = re.search('Price \(€\)', self.cnt)
        self.items_end = re.search('Total Net Value \(€\)', self.cnt)
        self.items_area = self.cnt[self.items_start.end()+3:self.items_end.start()].split(
            3 * ' ' + '\n')
        self.items_details = itemList(self.items_area)
        self.size = len(self.cnt[self.items_start.end()+3:self.items_end.start()].split(
            3 * ' ' + '\n')) - 1
        self.inv_nr = re.search('(?<=INV)[0-9]+', self.cnt).group(0)
        self.data = re.search('(?<=Date: ).+', self.cnt).group(0).replace(' ', '').replace('/', '.')
        self.vat_num = re.search('(?<=VAT No: )[A-Z0-9]+', self.cnt).group(0)

    def __getitem__(self, k):
        return self.__dict__[k]
    
    def __len__(self):
        return self.size
